searchNodes=[{"ref":"EctoLtree.Functions.html","title":"EctoLtree.Functions","type":"module","doc":"This module exposes the ltree functions. For more information see the PostgreSQL documentation."},{"ref":"EctoLtree.Functions.html#index/2","title":"EctoLtree.Functions.index/2","type":"macro","doc":"position of first occurrence of b in a; -1 if not found."},{"ref":"EctoLtree.Functions.html#index/3","title":"EctoLtree.Functions.index/3","type":"macro","doc":"position of first occurrence of b in a, searching starting at offset; negative offset means start -offset labels from the end of the path."},{"ref":"EctoLtree.Functions.html#lca/2","title":"EctoLtree.Functions.lca/2","type":"macro","doc":"lowest common ancestor."},{"ref":"EctoLtree.Functions.html#ltree2text/1","title":"EctoLtree.Functions.ltree2text/1","type":"macro","doc":"cast ltree to text."},{"ref":"EctoLtree.Functions.html#nlevel/1","title":"EctoLtree.Functions.nlevel/1","type":"macro","doc":"number of labels in path."},{"ref":"EctoLtree.Functions.html#subltree/3","title":"EctoLtree.Functions.subltree/3","type":"macro","doc":"subpath of ltree from position start to position end-1 (counting from 0)."},{"ref":"EctoLtree.Functions.html#subpath/2","title":"EctoLtree.Functions.subpath/2","type":"macro","doc":"subpath of ltree starting at position offset, extending to end of path. If offset is negative, subpath starts that far from the end of the path."},{"ref":"EctoLtree.Functions.html#subpath/3","title":"EctoLtree.Functions.subpath/3","type":"macro","doc":"subpath of ltree starting at position offset, length len. If offset is negative, subpath starts that far from the end of the path. If len is negative, leaves that many labels off the end of the path."},{"ref":"EctoLtree.Functions.html#text2ltree/1","title":"EctoLtree.Functions.text2ltree/1","type":"macro","doc":"cast text to ltree."},{"ref":"EctoLtree.LabelTree.html","title":"EctoLtree.LabelTree","type":"module","doc":"This module defines the LabelTree struct. Implements the Ecto.Type behaviour. Fields labels"},{"ref":"EctoLtree.LabelTree.html#cast/1","title":"EctoLtree.LabelTree.cast/1","type":"function","doc":"Provides custom casting rules from external data to internal representation."},{"ref":"EctoLtree.LabelTree.html#decode/1","title":"EctoLtree.LabelTree.decode/1","type":"function","doc":""},{"ref":"EctoLtree.LabelTree.html#dump/1","title":"EctoLtree.LabelTree.dump/1","type":"function","doc":"From internal representation to database."},{"ref":"EctoLtree.LabelTree.html#load/1","title":"EctoLtree.LabelTree.load/1","type":"function","doc":"From database to internal representation."},{"ref":"EctoLtree.LabelTree.html#type/0","title":"EctoLtree.LabelTree.type/0","type":"function","doc":"Returns the underlying schema type."},{"ref":"EctoLtree.LabelTree.html#t:t/0","title":"EctoLtree.LabelTree.t/0","type":"type","doc":""},{"ref":"EctoLtree.Postgrex.Lquery.html","title":"EctoLtree.Postgrex.Lquery","type":"module","doc":"This module provides the necessary functions to encode and decode PostgreSQL’s lquery data type to and from Elixir values. Implements the Postgrex.Extension behaviour."},{"ref":"EctoLtree.Postgrex.Lquery.html#decode/1","title":"EctoLtree.Postgrex.Lquery.decode/1","type":"function","doc":"Returns a quoted list of clauses that decode a binary to an Elixir value. The pattern must use binary syntax and decode a fixed length using the signed 32 bit big endian integer byte length header. def decode(_) do quote do # length header is in bytes &lt;&lt;len :: signed-32, integer :: signed-size(len)-unit(8)&gt;&gt; -&gt; integer end end Callback implementation for Postgrex.Extension.decode/1."},{"ref":"EctoLtree.Postgrex.Lquery.html#encode/1","title":"EctoLtree.Postgrex.Lquery.encode/1","type":"function","doc":"Returns a quoted list of clauses that encode an Elixir value to iodata. It must use a signed 32 bit big endian integer byte length header. def encode(_) do quote do integer -&gt; &lt;&lt;8 :: signed-32, integer :: signed-64&gt;&gt; end end Callback implementation for Postgrex.Extension.encode/1."},{"ref":"EctoLtree.Postgrex.Lquery.html#format/1","title":"EctoLtree.Postgrex.Lquery.format/1","type":"function","doc":"Returns the format the type should be encoded as. See http://www.postgresql.org/docs/9.4/static/protocol-overview.html#PROTOCOL-FORMAT-CODES. Callback implementation for Postgrex.Extension.format/1."},{"ref":"EctoLtree.Postgrex.Lquery.html#init/1","title":"EctoLtree.Postgrex.Lquery.init/1","type":"function","doc":"Should perform any initialization of the extension. The function receives the user options. The state returned from this function will be passed to other callbacks. Callback implementation for Postgrex.Extension.init/1."},{"ref":"EctoLtree.Postgrex.Lquery.html#matching/1","title":"EctoLtree.Postgrex.Lquery.matching/1","type":"function","doc":"Specifies the types the extension matches, see Postgrex.TypeInfo for specification of the fields. Callback implementation for Postgrex.Extension.matching/1."},{"ref":"EctoLtree.Postgrex.Ltree.html","title":"EctoLtree.Postgrex.Ltree","type":"module","doc":"This module provides the necessary functions to encode and decode PostgreSQL’s ltree data type to and from Elixir values. Implements the Postgrex.Extension behaviour."},{"ref":"EctoLtree.Postgrex.Ltree.html#decode/1","title":"EctoLtree.Postgrex.Ltree.decode/1","type":"function","doc":"Returns a quoted list of clauses that decode a binary to an Elixir value. The pattern must use binary syntax and decode a fixed length using the signed 32 bit big endian integer byte length header. def decode(_) do quote do # length header is in bytes &lt;&lt;len :: signed-32, integer :: signed-size(len)-unit(8)&gt;&gt; -&gt; integer end end Callback implementation for Postgrex.Extension.decode/1."},{"ref":"EctoLtree.Postgrex.Ltree.html#encode/1","title":"EctoLtree.Postgrex.Ltree.encode/1","type":"function","doc":"Returns a quoted list of clauses that encode an Elixir value to iodata. It must use a signed 32 bit big endian integer byte length header. def encode(_) do quote do integer -&gt; &lt;&lt;8 :: signed-32, integer :: signed-64&gt;&gt; end end Callback implementation for Postgrex.Extension.encode/1."},{"ref":"EctoLtree.Postgrex.Ltree.html#format/1","title":"EctoLtree.Postgrex.Ltree.format/1","type":"function","doc":"Returns the format the type should be encoded as. See http://www.postgresql.org/docs/9.4/static/protocol-overview.html#PROTOCOL-FORMAT-CODES. Callback implementation for Postgrex.Extension.format/1."},{"ref":"EctoLtree.Postgrex.Ltree.html#init/1","title":"EctoLtree.Postgrex.Ltree.init/1","type":"function","doc":"Should perform any initialization of the extension. The function receives the user options. The state returned from this function will be passed to other callbacks. Callback implementation for Postgrex.Extension.init/1."},{"ref":"EctoLtree.Postgrex.Ltree.html#matching/1","title":"EctoLtree.Postgrex.Ltree.matching/1","type":"function","doc":"Specifies the types the extension matches, see Postgrex.TypeInfo for specification of the fields. Callback implementation for Postgrex.Extension.matching/1."},{"ref":"readme.html","title":"EctoLtree","type":"extras","doc":"EctoLtree A library that provides the necessary modules to support the PostgreSQL’s ltree data type with Ecto."},{"ref":"readme.html#quickstart","title":"EctoLtree - Quickstart","type":"extras","doc":"1. Add the package to your list of dependencies in mix.exs If you are using Elixir &gt;= v1.7 and Ecto ~&gt; 3.0 def deps do [ ... {:ecto_ltree, &quot;~&gt; 0.2.0&quot;} ] end If you are using Elixir v1.6 and Ecto ~&gt; 2.1 def deps do [ ... {:ecto_ltree, &quot;~&gt; 0.1.0&quot;} ] end 2. Define a type module with our custom extensions Postgrex.Types.define( MyApp.PostgresTypes, [EctoLtree.Postgrex.Lquery, EctoLtree.Postgrex.Ltree] ++ Ecto.Adapters.Postgres.extensions() ) 3. Configure the Repo to use the previously defined type module config :my_app, MyApp.Repo, adapter: Ecto.Adapters.Postgres, username: &quot;postgres&quot;, password: &quot;postgres&quot;, database: &quot;my_app_dev&quot;, hostname: &quot;localhost&quot;, poolsize: 10, pool: Ecto.Adapters.SQL.Sandbox, types: MyApp.PostgresTypes 4. Add a migration to enable the ltree extension defmodule MyApp.Repo.Migrations.CreateExtensionLtree do use Ecto.Migration def change do execute(&quot;CREATE EXTENSION ltree&quot;, &quot;DROP EXTENSION ltree&quot;) end end 5. Add a migration to create your table defmodule MyApp.Repo.Migrations.CreateItems do use Ecto.Migration def change do create table(:items) do add :path, :ltree end create index(:items, [:path], using: :gist) end end 6. Define an Ecto Schema defmodule MyApp.Item do use Ecto.Schema import Ecto.Changeset alias EctoLtree.LabelTree, as: Ltree schema &quot;items&quot; do field :path, Ltree end def changeset(item, params \\\\ %{}) do item |&gt; cast(params, [:path]) end end 7. Usage iex(1)&gt; alias MyApp.Repo MyApp.Repo iex(2)&gt; alias MyApp.Item MyApp.Item iex(3)&gt; import Ecto.Query Ecto.Query iex(4)&gt; import EctoLtree.Functions EctoLtree.Functions iex(5)&gt; Item.changeset(%Item{}, %{path: “1.2.3”}) |&gt; Repo.insert! %MyApp.Item{ __meta__: #Ecto.Schema.Metadata&lt;:loaded, “items”&gt;, id: 1, path: %EctoLtree.LabelTree{labels: [“1”, “2”, “3”]} } iex(6)&gt; from(item in Item, select: nlevel(item.path)) |&gt; Repo.one 3 The documentation can be found at hexdocs."},{"ref":"readme.html#copyright-and-license","title":"EctoLtree - Copyright and License","type":"extras","doc":"Copyright (c) 2018-2019 Jose Miguel Rivero Bruno The source code is licensed under The MIT License (MIT)"}]